/**
  * This file was generated from model [DebuggerModel] on [Sat Apr 15 23:19:34 MSD 2006].
  * Do not change content of this file.
  */

package ;

import java.util.*;

import com.evelopers.common.exception.*;
import com.evelopers.unimod.core.stateworks.*;
import com.evelopers.unimod.runtime.*;
import com.evelopers.unimod.runtime.context.*;


public class DebuggerModelEventProcessor extends AbstractEventProcessor {

	private ModelStructure modelStructure;

				private static final int debugger = 1;
			private static final int A2 = 2;
			private static final int A3 = 3;
	
	private int decodeStateMachine(String sm) {
					
		if ("debugger".equals(sm)) {
			return debugger;
						} else 
				
		if ("A2".equals(sm)) {
			return A2;
						} else 
				
		if ("A3".equals(sm)) {
			return A3;
			}

		return -1;
	}
		
			private debuggerEventProcessor _debugger;
			private A2EventProcessor _A2;
			private A3EventProcessor _A3;
		
	public DebuggerModelEventProcessor() {
		modelStructure = new DebuggerModelModelStructure();

					_debugger = new debuggerEventProcessor();
					_A2 = new A2EventProcessor();
					_A3 = new A3EventProcessor();
			}

    public ModelStructure getModelStructure() {
		return modelStructure;
	}	
	
    public void setControlledObjectsMap(ControlledObjectsMap controlledObjectsMap) {
        super.setControlledObjectsMap(controlledObjectsMap);
		
					_debugger.init(controlledObjectsMap);
					_A2.init(controlledObjectsMap);
					_A3.init(controlledObjectsMap);
		    }

	protected StateMachineConfig process(
            Event event, StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

		// get state machine from path
		int sm = decodeStateMachine(path.getStateMachine());
		
		try {
		switch (sm) {
					case debugger:
				return _debugger.process(event, context, path, config);
					case A2:
				return _A2.process(event, context, path, config);
					case A3:
				return _A3.process(event, context, path, config);
					default:
				throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
		}
		} catch (Exception e) {
			if (e instanceof SystemException) {
				throw (SystemException)e;
			} else {
				throw new SystemException(e);
			}
		}
	}

    protected StateMachineConfig transiteToStableState(
            StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

		// get state machine from path
		int sm = decodeStateMachine(path.getStateMachine());

		try {
		switch (sm) {
					case debugger:
				return _debugger.transiteToStableState(context, path, config);
					case A2:
				return _A2.transiteToStableState(context, path, config);
					case A3:
				return _A3.transiteToStableState(context, path, config);
					default:
				throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
		}
		} catch (Exception e) {
			if (e instanceof SystemException) {
				throw (SystemException)e;
			} else {
				throw new SystemException(e);
			}
		}
	}	

	private class DebuggerModelModelStructure implements ModelStructure {

	private Map configManagers = new HashMap();

	private DebuggerModelModelStructure() {
					configManagers.put("debugger", new com.evelopers.unimod.runtime.config.DistinguishConfigManager());
					configManagers.put("A2", new com.evelopers.unimod.runtime.config.SharedStateConfigManager());
					configManagers.put("A3", new com.evelopers.unimod.debug.ThreadConfigManager());
			}

	public StateMachinePath getRootPath() throws EventProcessorException {
		return new StateMachinePath("debugger");				
	}

	public StateMachineConfigManager getConfigManager(String stateMachine) throws EventProcessorException {
		return (StateMachineConfigManager)configManagers.get(stateMachine);
	}

	public StateMachineConfig getTopConfig(String stateMachine) throws EventProcessorException {
		int sm = decodeStateMachine(stateMachine);
		
		switch (sm) {
					case debugger:
				return new StateMachineConfig("Top");
					case A2:
				return new StateMachineConfig("Top");
					case A3:
				return new StateMachineConfig("Top");
					default:
				throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
		}
	}

	public boolean isFinal(String stateMachine, StateMachineConfig config) throws EventProcessorException {
		// get state machine from path
		int sm = decodeStateMachine(stateMachine);
		int state;
		
		switch (sm) {
					case debugger:
				state = _debugger.decodeState(config.getActiveState());
				switch (state) {
																																					case debuggerEventProcessor.s2:
																																																						    return true;
									default:
						return false;
				}
					case A2:
				state = _A2.decodeState(config.getActiveState());
				switch (state) {
																																												default:
						return false;
				}
					case A3:
				state = _A3.decodeState(config.getActiveState());
				switch (state) {
																																																														default:
						return false;
				}
					default:
				throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
		}
	}			
}	
			







private class debuggerEventProcessor {

		// states
	    private static final int Top = 1;
	    private static final int s3 = 2;
	    private static final int s2 = 3;
	    private static final int Connected_to_app = 4;
	    private static final int Wait_for_threads = 5;
	    private static final int s1 = 6;
	    private static final int Threads_exists = 7;
	
	private int decodeState(String state) {
					
		if ("Top".equals(state)) {
			return Top;
						} else 
				
		if ("s3".equals(state)) {
			return s3;
						} else 
				
		if ("s2".equals(state)) {
			return s2;
						} else 
				
		if ("Connected to app".equals(state)) {
			return Connected_to_app;
						} else 
				
		if ("Wait for threads".equals(state)) {
			return Wait_for_threads;
						} else 
				
		if ("s1".equals(state)) {
			return s1;
						} else 
				
		if ("Threads exists".equals(state)) {
			return Threads_exists;
			}
		
		return -1;
	}
	
		// events
	    private static final int e26 = 1;
	    private static final int e2 = 2;
	    private static final int e25 = 3;
	    private static final int e3 = 4;
	    private static final int e8 = 5;
	    private static final int e4 = 6;
	    private static final int e24 = 7;
	    private static final int e7 = 8;
	    private static final int e5 = 9;
	    private static final int e1 = 10;
	    private static final int e23 = 11;
	    private static final int e6 = 12;
	
	private int decodeEvent(String event) {
					
		if ("e26".equals(event)) {
			return e26;
						} else 
				
		if ("e2".equals(event)) {
			return e2;
						} else 
				
		if ("e25".equals(event)) {
			return e25;
						} else 
				
		if ("e3".equals(event)) {
			return e3;
						} else 
				
		if ("e8".equals(event)) {
			return e8;
						} else 
				
		if ("e4".equals(event)) {
			return e4;
						} else 
				
		if ("e24".equals(event)) {
			return e24;
						} else 
				
		if ("e7".equals(event)) {
			return e7;
						} else 
				
		if ("e5".equals(event)) {
			return e5;
						} else 
				
		if ("e1".equals(event)) {
			return e1;
						} else 
				
		if ("e23".equals(event)) {
			return e23;
						} else 
				
		if ("e6".equals(event)) {
			return e6;
				}
	
		return -1;
	}
		
										private com.evelopers.unimod.debug.debugger.UIManager o2;
				
	private void init(ControlledObjectsMap controlledObjectsMap) {
														o2 = (com.evelopers.unimod.debug.debugger.UIManager)controlledObjectsMap.getControlledObject("o2");
						}
		
	private StateMachineConfig process(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		config = lookForTransition(event, context, path, config);
		
		config = transiteToStableState(context, path, config);
		
		// execute included state machines
		executeSubmachines(event, context, path, config);
		
		return config;
	}
	
	private void executeSubmachines(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		int state = decodeState(config.getActiveState());
		
		while (true) {
		switch (state) {
																			case s3: 
					
											return;
																					case s2: 
					
											return;
																					case Connected_to_app: 
					
											return;
																					case Wait_for_threads: 
																					// Wait for threads includes A2
	
	fireBeforeSubmachineExecution(context, event, path, "Wait for threads", "A2");
	
	DebuggerModelEventProcessor.this.process(event, context, new StateMachinePath(path,
		"Wait for threads", "A2"));

    fireAfterSubmachineExecution(context, event, path, "Wait for threads", "A2");
												
											state = Connected_to_app;
						break;
																					case s1: 
					
											state = Connected_to_app;
						break;
																					case Threads_exists: 
																					// Threads exists includes A2
	
	fireBeforeSubmachineExecution(context, event, path, "Threads exists", "A2");
	
	DebuggerModelEventProcessor.this.process(event, context, new StateMachinePath(path,
		"Threads exists", "A2"));

    fireAfterSubmachineExecution(context, event, path, "Threads exists", "A2");
												
											state = Connected_to_app;
						break;
																default:
					throw new EventProcessorException("State with name [" + config.getActiveState() + "] is unknown for state machine [debugger]");
		}
		}
	}
	
	private StateMachineConfig transiteToStableState(StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {

		int s = decodeState(config.getActiveState());
		Event event;

		switch (s) {
									case Top:
					
										
					fireComeToState(context, path, "s3");

					// s3->Connected to app [true]/
					event = Event.NO_EVENT;
						fireTransitionFound(context, path, "s3", event, "s3#Connected to app##true");
	
		
	fireComeToState(context, path, "Connected to app");
	
	// Connected to app []
						
											return transiteToStableState(context, path, new StateMachineConfig("Connected to app"));
																											case Connected_to_app:
											fireCompositeTargetState(context, path, "Connected to app");
					
										
					fireComeToState(context, path, "s1");

					// s1->Wait for threads [true]/
					event = Event.NO_EVENT;
						fireTransitionFound(context, path, "s1", event, "s1#Wait for threads##true");
	
		
	fireComeToState(context, path, "Wait for threads");
	
	// Wait for threads []
						
											return new StateMachineConfig("Wait for threads");
																											}
	
		return config;
	}    
	
	private StateMachineConfig lookForTransition(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
					
		
				
		
	
				BitSet calculatedInputActions = new BitSet(0);
		
		int s = decodeState(config.getActiveState());
		int e = decodeEvent(event.getName());
	
		while (true) {
			switch (s) {
																																	case Connected_to_app:
						
													fireTransitionsOfSuperstate(context, path, "Connected to app", event);
											
												switch (e) {
													case e4:
																
						// Connected to app->s2 e4[true]/o2.z4
			
			fireTransitionCandidate(context, path, "Connected to app", event, "Connected to app#s2#e4#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Connected to app", event, "Connected to app#s2#e4#true");
	
				fireBeforeOutputActionExecution(context, path, "Connected to app#s2#e4#true", "o2.z4");

				o2.z4(context);
		
	fireAfterOutputActionExecution(context, path, "Connected to app#s2#e4#true", "o2.z4");
		
	fireComeToState(context, path, "s2");
	
	// s2 []
					return new StateMachineConfig("s2");

																				
														case e26:
																
						// Connected to app->s2 e26[true]/
			
			fireTransitionCandidate(context, path, "Connected to app", event, "Connected to app#s2#e26#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Connected to app", event, "Connected to app#s2#e26#true");
	
		
	fireComeToState(context, path, "s2");
	
	// s2 []
					return new StateMachineConfig("s2");

																				
														case e25:
																
						// Connected to app->s2 e25[true]/
			
			fireTransitionCandidate(context, path, "Connected to app", event, "Connected to app#s2#e25#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Connected to app", event, "Connected to app#s2#e25#true");
	
		
	fireComeToState(context, path, "s2");
	
	// s2 []
					return new StateMachineConfig("s2");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case Wait_for_threads:
						
											
												switch (e) {
													case e4:
																
							
										// go to super state only if it process given event or any event
									s = Connected_to_app;
					break;
																							case e26:
																
							
										// go to super state only if it process given event or any event
									s = Connected_to_app;
					break;
																							case e7:
																
						// Wait for threads->Threads exists e7[true]/A3.e7
			
			fireTransitionCandidate(context, path, "Wait for threads", event, "Wait for threads#Threads exists#e7#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Wait for threads", event, "Wait for threads#Threads exists#e7#true");
	
				fireBeforeOutputActionExecution(context, path, "Wait for threads#Threads exists#e7#true", "A3.e7");

		                        DebuggerModelEventProcessor.this.process(new Event("e7"), context, 
			new StateMachinePath("A3"));
		
	fireAfterOutputActionExecution(context, path, "Wait for threads#Threads exists#e7#true", "A3.e7");
		
	fireComeToState(context, path, "Threads exists");
	
	// Threads exists []
					return new StateMachineConfig("Threads exists");

																				
														case e5:
																
						// Wait for threads->Wait for threads e5[true]/o2.z5
			
			fireTransitionCandidate(context, path, "Wait for threads", event, "Wait for threads#Wait for threads#e5#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Wait for threads", event, "Wait for threads#Wait for threads#e5#true");
	
				fireBeforeOutputActionExecution(context, path, "Wait for threads#Wait for threads#e5#true", "o2.z5");

				o2.z5(context);
		
	fireAfterOutputActionExecution(context, path, "Wait for threads#Wait for threads#e5#true", "o2.z5");
		
	fireComeToState(context, path, "Wait for threads");
	
	// Wait for threads []
					return new StateMachineConfig("Wait for threads");

																				
														case e25:
																
							
										// go to super state only if it process given event or any event
									s = Connected_to_app;
					break;
																							case e6:
																
						// Wait for threads->Wait for threads e6[true]/o2.z6
			
			fireTransitionCandidate(context, path, "Wait for threads", event, "Wait for threads#Wait for threads#e6#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Wait for threads", event, "Wait for threads#Wait for threads#e6#true");
	
				fireBeforeOutputActionExecution(context, path, "Wait for threads#Wait for threads#e6#true", "o2.z6");

				o2.z6(context);
		
	fireAfterOutputActionExecution(context, path, "Wait for threads#Wait for threads#e6#true", "o2.z6");
		
	fireComeToState(context, path, "Wait for threads");
	
	// Wait for threads []
					return new StateMachineConfig("Wait for threads");

																				
														case e8:
																
						// Wait for threads->Wait for threads e8[true]/o2.z8
			
			fireTransitionCandidate(context, path, "Wait for threads", event, "Wait for threads#Wait for threads#e8#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Wait for threads", event, "Wait for threads#Wait for threads#e8#true");
	
				fireBeforeOutputActionExecution(context, path, "Wait for threads#Wait for threads#e8#true", "o2.z8");

				o2.z8(context);
		
	fireAfterOutputActionExecution(context, path, "Wait for threads#Wait for threads#e8#true", "o2.z8");
		
	fireComeToState(context, path, "Wait for threads");
	
	// Wait for threads []
					return new StateMachineConfig("Wait for threads");

																				
													default:
														
							
										// go to super state only if it process given event or any event
									// transition not found
										return config;
																}
						
													break;
																													case Threads_exists:
						
											
												switch (e) {
													case e4:
																
							
										// go to super state only if it process given event or any event
									s = Connected_to_app;
					break;
																							case e24:
																
						// Threads exists->Threads exists e24[true]/A3.e24
			
			fireTransitionCandidate(context, path, "Threads exists", event, "Threads exists#Threads exists#e24#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Threads exists", event, "Threads exists#Threads exists#e24#true");
	
				fireBeforeOutputActionExecution(context, path, "Threads exists#Threads exists#e24#true", "A3.e24");

		                        DebuggerModelEventProcessor.this.process(new Event("e24"), context, 
			new StateMachinePath("A3"));
		
	fireAfterOutputActionExecution(context, path, "Threads exists#Threads exists#e24#true", "A3.e24");
		
	fireComeToState(context, path, "Threads exists");
	
	// Threads exists []
					return new StateMachineConfig("Threads exists");

																				
														case e26:
																
							
										// go to super state only if it process given event or any event
									s = Connected_to_app;
					break;
																							case e2:
																
						// Threads exists->Threads exists e2[true]/A3.e2
			
			fireTransitionCandidate(context, path, "Threads exists", event, "Threads exists#Threads exists#e2#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Threads exists", event, "Threads exists#Threads exists#e2#true");
	
				fireBeforeOutputActionExecution(context, path, "Threads exists#Threads exists#e2#true", "A3.e2");

		                        DebuggerModelEventProcessor.this.process(new Event("e2"), context, 
			new StateMachinePath("A3"));
		
	fireAfterOutputActionExecution(context, path, "Threads exists#Threads exists#e2#true", "A3.e2");
		
	fireComeToState(context, path, "Threads exists");
	
	// Threads exists []
					return new StateMachineConfig("Threads exists");

																				
														case e7:
																
						// Threads exists->Threads exists e7[true]/A3.e7
			
			fireTransitionCandidate(context, path, "Threads exists", event, "Threads exists#Threads exists#e7#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Threads exists", event, "Threads exists#Threads exists#e7#true");
	
				fireBeforeOutputActionExecution(context, path, "Threads exists#Threads exists#e7#true", "A3.e7");

		                        DebuggerModelEventProcessor.this.process(new Event("e7"), context, 
			new StateMachinePath("A3"));
		
	fireAfterOutputActionExecution(context, path, "Threads exists#Threads exists#e7#true", "A3.e7");
		
	fireComeToState(context, path, "Threads exists");
	
	// Threads exists []
					return new StateMachineConfig("Threads exists");

																				
														case e5:
																
						// Threads exists->Threads exists e5[true]/o2.z5
			
			fireTransitionCandidate(context, path, "Threads exists", event, "Threads exists#Threads exists#e5#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Threads exists", event, "Threads exists#Threads exists#e5#true");
	
				fireBeforeOutputActionExecution(context, path, "Threads exists#Threads exists#e5#true", "o2.z5");

				o2.z5(context);
		
	fireAfterOutputActionExecution(context, path, "Threads exists#Threads exists#e5#true", "o2.z5");
		
	fireComeToState(context, path, "Threads exists");
	
	// Threads exists []
					return new StateMachineConfig("Threads exists");

																				
														case e25:
																
							
										// go to super state only if it process given event or any event
									s = Connected_to_app;
					break;
																							case e1:
																
						// Threads exists->Threads exists e1[true]/A3.e1
			
			fireTransitionCandidate(context, path, "Threads exists", event, "Threads exists#Threads exists#e1#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Threads exists", event, "Threads exists#Threads exists#e1#true");
	
				fireBeforeOutputActionExecution(context, path, "Threads exists#Threads exists#e1#true", "A3.e1");

		                        DebuggerModelEventProcessor.this.process(new Event("e1"), context, 
			new StateMachinePath("A3"));
		
	fireAfterOutputActionExecution(context, path, "Threads exists#Threads exists#e1#true", "A3.e1");
		
	fireComeToState(context, path, "Threads exists");
	
	// Threads exists []
					return new StateMachineConfig("Threads exists");

																				
														case e23:
																
						// Threads exists->Threads exists e23[true]/A3.e23
			
			fireTransitionCandidate(context, path, "Threads exists", event, "Threads exists#Threads exists#e23#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Threads exists", event, "Threads exists#Threads exists#e23#true");
	
				fireBeforeOutputActionExecution(context, path, "Threads exists#Threads exists#e23#true", "A3.e23");

		                        DebuggerModelEventProcessor.this.process(new Event("e23"), context, 
			new StateMachinePath("A3"));
		
	fireAfterOutputActionExecution(context, path, "Threads exists#Threads exists#e23#true", "A3.e23");
		
	fireComeToState(context, path, "Threads exists");
	
	// Threads exists []
					return new StateMachineConfig("Threads exists");

																				
														case e3:
																
						// Threads exists->Threads exists e3[true]/A3.e3
			
			fireTransitionCandidate(context, path, "Threads exists", event, "Threads exists#Threads exists#e3#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Threads exists", event, "Threads exists#Threads exists#e3#true");
	
				fireBeforeOutputActionExecution(context, path, "Threads exists#Threads exists#e3#true", "A3.e3");

		                        DebuggerModelEventProcessor.this.process(new Event("e3"), context, 
			new StateMachinePath("A3"));
		
	fireAfterOutputActionExecution(context, path, "Threads exists#Threads exists#e3#true", "A3.e3");
		
	fireComeToState(context, path, "Threads exists");
	
	// Threads exists []
					return new StateMachineConfig("Threads exists");

																				
														case e6:
																
						// Threads exists->Threads exists e6[true]/o2.z6
			
			fireTransitionCandidate(context, path, "Threads exists", event, "Threads exists#Threads exists#e6#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Threads exists", event, "Threads exists#Threads exists#e6#true");
	
				fireBeforeOutputActionExecution(context, path, "Threads exists#Threads exists#e6#true", "o2.z6");

				o2.z6(context);
		
	fireAfterOutputActionExecution(context, path, "Threads exists#Threads exists#e6#true", "o2.z6");
		
	fireComeToState(context, path, "Threads exists");
	
	// Threads exists []
					return new StateMachineConfig("Threads exists");

																				
														case e8:
																
						// Threads exists->Threads exists e8[true]/o2.z8
			
			fireTransitionCandidate(context, path, "Threads exists", event, "Threads exists#Threads exists#e8#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Threads exists", event, "Threads exists#Threads exists#e8#true");
	
				fireBeforeOutputActionExecution(context, path, "Threads exists#Threads exists#e8#true", "o2.z8");

				o2.z8(context);
		
	fireAfterOutputActionExecution(context, path, "Threads exists#Threads exists#e8#true", "o2.z8");
		
	fireComeToState(context, path, "Threads exists");
	
	// Threads exists []
					return new StateMachineConfig("Threads exists");

																				
													default:
														
							
										// go to super state only if it process given event or any event
									// transition not found
										return config;
																}
						
													break;
																	default:
					throw new EventProcessorException("Incorrect stable state [" + config.getActiveState() + "] in state machine [debugger]");
			}
		}
	}

		        
}
			







private class A2EventProcessor {

		// states
	    private static final int Top = 1;
	    private static final int s1 = 2;
	    private static final int Ready = 3;
	
	private int decodeState(String state) {
					
		if ("Top".equals(state)) {
			return Top;
						} else 
				
		if ("s1".equals(state)) {
			return s1;
						} else 
				
		if ("Ready".equals(state)) {
			return Ready;
			}
		
		return -1;
	}
	
		// events
	    private static final int e22 = 1;
	    private static final int e21 = 2;
	    private static final int e27 = 3;
	
	private int decodeEvent(String event) {
					
		if ("e22".equals(event)) {
			return e22;
						} else 
				
		if ("e21".equals(event)) {
			return e21;
						} else 
				
		if ("e27".equals(event)) {
			return e27;
				}
	
		return -1;
	}
		
							private com.evelopers.unimod.debug.debugger.BreakpointManager o3;
								private com.evelopers.unimod.debug.debugger.DebuggerConnector o1;
				
	private void init(ControlledObjectsMap controlledObjectsMap) {
									o3 = (com.evelopers.unimod.debug.debugger.BreakpointManager)controlledObjectsMap.getControlledObject("o3");
												o1 = (com.evelopers.unimod.debug.debugger.DebuggerConnector)controlledObjectsMap.getControlledObject("o1");
						}
		
	private StateMachineConfig process(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		config = lookForTransition(event, context, path, config);
		
		config = transiteToStableState(context, path, config);
		
		// execute included state machines
		executeSubmachines(event, context, path, config);
		
		return config;
	}
	
	private void executeSubmachines(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		int state = decodeState(config.getActiveState());
		
		while (true) {
		switch (state) {
																			case s1: 
					
											return;
																					case Ready: 
					
											return;
																default:
					throw new EventProcessorException("State with name [" + config.getActiveState() + "] is unknown for state machine [A2]");
		}
		}
	}
	
	private StateMachineConfig transiteToStableState(StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {

		int s = decodeState(config.getActiveState());
		Event event;

		switch (s) {
									case Top:
					
										
					fireComeToState(context, path, "s1");

					// s1->Ready [true]/o3.z1,o1.z1
					event = Event.NO_EVENT;
						fireTransitionFound(context, path, "s1", event, "s1#Ready##true");
	
				fireBeforeOutputActionExecution(context, path, "s1#Ready##true", "o3.z1");

				o3.z1(context);
		
	fireAfterOutputActionExecution(context, path, "s1#Ready##true", "o3.z1");
				fireBeforeOutputActionExecution(context, path, "s1#Ready##true", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "s1#Ready##true", "o1.z1");
		
	fireComeToState(context, path, "Ready");
	
	// Ready []
						
											return new StateMachineConfig("Ready");
																						}
	
		return config;
	}    
	
	private StateMachineConfig lookForTransition(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
					
		
				
		
	
				BitSet calculatedInputActions = new BitSet(0);
		
		int s = decodeState(config.getActiveState());
		int e = decodeEvent(event.getName());
	
		while (true) {
			switch (s) {
																										case Ready:
						
											
												switch (e) {
													case e22:
																
						// Ready->Ready e22[true]/o1.z2
			
			fireTransitionCandidate(context, path, "Ready", event, "Ready#Ready#e22#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Ready", event, "Ready#Ready#e22#true");
	
				fireBeforeOutputActionExecution(context, path, "Ready#Ready#e22#true", "o1.z2");

				o1.z2(context);
		
	fireAfterOutputActionExecution(context, path, "Ready#Ready#e22#true", "o1.z2");
		
	fireComeToState(context, path, "Ready");
	
	// Ready []
					return new StateMachineConfig("Ready");

																				
														case e21:
																
						// Ready->Ready e21[true]/o1.z1
			
			fireTransitionCandidate(context, path, "Ready", event, "Ready#Ready#e21#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Ready", event, "Ready#Ready#e21#true");
	
				fireBeforeOutputActionExecution(context, path, "Ready#Ready#e21#true", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "Ready#Ready#e21#true", "o1.z1");
		
	fireComeToState(context, path, "Ready");
	
	// Ready []
					return new StateMachineConfig("Ready");

																				
														case e27:
																
						// Ready->Ready e27[true]/o1.z5
			
			fireTransitionCandidate(context, path, "Ready", event, "Ready#Ready#e27#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Ready", event, "Ready#Ready#e27#true");
	
				fireBeforeOutputActionExecution(context, path, "Ready#Ready#e27#true", "o1.z5");

				o1.z5(context);
		
	fireAfterOutputActionExecution(context, path, "Ready#Ready#e27#true", "o1.z5");
		
	fireComeToState(context, path, "Ready");
	
	// Ready []
					return new StateMachineConfig("Ready");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																	default:
					throw new EventProcessorException("Incorrect stable state [" + config.getActiveState() + "] in state machine [A2]");
			}
		}
	}

		        
}
			







private class A3EventProcessor {

		// states
	    private static final int Top = 1;
	    private static final int s1 = 2;
	    private static final int No_Thread = 3;
	    private static final int Suspended = 4;
	    private static final int Resumed = 5;
	
	private int decodeState(String state) {
					
		if ("Top".equals(state)) {
			return Top;
						} else 
				
		if ("s1".equals(state)) {
			return s1;
						} else 
				
		if ("No Thread".equals(state)) {
			return No_Thread;
						} else 
				
		if ("Suspended".equals(state)) {
			return Suspended;
						} else 
				
		if ("Resumed".equals(state)) {
			return Resumed;
			}
		
		return -1;
	}
	
		// events
	    private static final int e24 = 1;
	    private static final int e2 = 2;
	    private static final int e7 = 3;
	    private static final int e1 = 4;
	    private static final int e23 = 5;
	    private static final int e3 = 6;
	
	private int decodeEvent(String event) {
					
		if ("e24".equals(event)) {
			return e24;
						} else 
				
		if ("e2".equals(event)) {
			return e2;
						} else 
				
		if ("e7".equals(event)) {
			return e7;
						} else 
				
		if ("e1".equals(event)) {
			return e1;
						} else 
				
		if ("e23".equals(event)) {
			return e23;
						} else 
				
		if ("e3".equals(event)) {
			return e3;
				}
	
		return -1;
	}
		
							private com.evelopers.unimod.debug.debugger.DebuggerConnector o1;
								private com.evelopers.unimod.debug.debugger.UIManager o2;
				
	private void init(ControlledObjectsMap controlledObjectsMap) {
									o1 = (com.evelopers.unimod.debug.debugger.DebuggerConnector)controlledObjectsMap.getControlledObject("o1");
												o2 = (com.evelopers.unimod.debug.debugger.UIManager)controlledObjectsMap.getControlledObject("o2");
						}
		
	private StateMachineConfig process(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		config = lookForTransition(event, context, path, config);
		
		config = transiteToStableState(context, path, config);
		
		// execute included state machines
		executeSubmachines(event, context, path, config);
		
		return config;
	}
	
	private void executeSubmachines(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		int state = decodeState(config.getActiveState());
		
		while (true) {
		switch (state) {
																			case s1: 
					
											return;
																					case No_Thread: 
					
											return;
																					case Suspended: 
					
											return;
																					case Resumed: 
					
											return;
																default:
					throw new EventProcessorException("State with name [" + config.getActiveState() + "] is unknown for state machine [A3]");
		}
		}
	}
	
	private StateMachineConfig transiteToStableState(StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {

		int s = decodeState(config.getActiveState());
		Event event;

		switch (s) {
									case Top:
					
										
					fireComeToState(context, path, "s1");

					// s1->No Thread [true]/
					event = Event.NO_EVENT;
						fireTransitionFound(context, path, "s1", event, "s1#No Thread##true");
	
		
	fireComeToState(context, path, "No Thread");
	
	// No Thread []
						
											return new StateMachineConfig("No Thread");
																																}
	
		return config;
	}    
	
	private StateMachineConfig lookForTransition(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
					
		
				
		
	
				BitSet calculatedInputActions = new BitSet(0);
		
		int s = decodeState(config.getActiveState());
		int e = decodeEvent(event.getName());
	
		while (true) {
			switch (s) {
																										case No_Thread:
						
											
												switch (e) {
													case e7:
																
						// No Thread->Resumed e7[true]/o2.z7
			
			fireTransitionCandidate(context, path, "No Thread", event, "No Thread#Resumed#e7#true");
			
						
							
			
							
					fireTransitionFound(context, path, "No Thread", event, "No Thread#Resumed#e7#true");
	
				fireBeforeOutputActionExecution(context, path, "No Thread#Resumed#e7#true", "o2.z7");

				o2.z7(context);
		
	fireAfterOutputActionExecution(context, path, "No Thread#Resumed#e7#true", "o2.z7");
		
	fireComeToState(context, path, "Resumed");
	
	// Resumed []
					return new StateMachineConfig("Resumed");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case Suspended:
						
											
												switch (e) {
													case e24:
																
						// Suspended->Suspended e24[true]/o1.z4
			
			fireTransitionCandidate(context, path, "Suspended", event, "Suspended#Suspended#e24#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Suspended", event, "Suspended#Suspended#e24#true");
	
				fireBeforeOutputActionExecution(context, path, "Suspended#Suspended#e24#true", "o1.z4");

				o1.z4(context);
		
	fireAfterOutputActionExecution(context, path, "Suspended#Suspended#e24#true", "o1.z4");
		
	fireComeToState(context, path, "Suspended");
	
	// Suspended []
					return new StateMachineConfig("Suspended");

																				
														case e23:
																
						// Suspended->Suspended e23[true]/o1.z3
			
			fireTransitionCandidate(context, path, "Suspended", event, "Suspended#Suspended#e23#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Suspended", event, "Suspended#Suspended#e23#true");
	
				fireBeforeOutputActionExecution(context, path, "Suspended#Suspended#e23#true", "o1.z3");

				o1.z3(context);
		
	fireAfterOutputActionExecution(context, path, "Suspended#Suspended#e23#true", "o1.z3");
		
	fireComeToState(context, path, "Suspended");
	
	// Suspended []
					return new StateMachineConfig("Suspended");

																				
														case e3:
																
						// Suspended->Resumed e3[true]/o2.z3
			
			fireTransitionCandidate(context, path, "Suspended", event, "Suspended#Resumed#e3#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Suspended", event, "Suspended#Resumed#e3#true");
	
				fireBeforeOutputActionExecution(context, path, "Suspended#Resumed#e3#true", "o2.z3");

				o2.z3(context);
		
	fireAfterOutputActionExecution(context, path, "Suspended#Resumed#e3#true", "o2.z3");
		
	fireComeToState(context, path, "Resumed");
	
	// Resumed []
					return new StateMachineConfig("Resumed");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case Resumed:
						
											
												switch (e) {
													case e2:
																
						// Resumed->Suspended e2[true]/o2.z2
			
			fireTransitionCandidate(context, path, "Resumed", event, "Resumed#Suspended#e2#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Resumed", event, "Resumed#Suspended#e2#true");
	
				fireBeforeOutputActionExecution(context, path, "Resumed#Suspended#e2#true", "o2.z2");

				o2.z2(context);
		
	fireAfterOutputActionExecution(context, path, "Resumed#Suspended#e2#true", "o2.z2");
		
	fireComeToState(context, path, "Suspended");
	
	// Suspended []
					return new StateMachineConfig("Suspended");

																				
														case e1:
																
						// Resumed->Suspended e1[true]/o2.z1
			
			fireTransitionCandidate(context, path, "Resumed", event, "Resumed#Suspended#e1#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Resumed", event, "Resumed#Suspended#e1#true");
	
				fireBeforeOutputActionExecution(context, path, "Resumed#Suspended#e1#true", "o2.z1");

				o2.z1(context);
		
	fireAfterOutputActionExecution(context, path, "Resumed#Suspended#e1#true", "o2.z1");
		
	fireComeToState(context, path, "Suspended");
	
	// Suspended []
					return new StateMachineConfig("Suspended");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																	default:
					throw new EventProcessorException("Incorrect stable state [" + config.getActiveState() + "] in state machine [A3]");
			}
		}
	}

		        
}
	
	private static boolean isInputActionCalculated(BitSet calculatedInputActions, int k) {
		boolean b = calculatedInputActions.get(k);
            
        if (!b) {
			calculatedInputActions.set(k);
		}
            
        return b;
	}
	
}
	
