/**
  * This file was generated from model [Model1] on [Fri Oct 13 20:26:27 MSD 2006].
  * Do not change content of this file.
  */

#include "Model1ModelEngine.h"

CModel1ModelEngine* CModel1ModelEngine::NewL(
        ru.ifmo.lift.MainForm* aOForm,
        ru.ifmo.lift.Lift* aOLift)
    {
    CModel1ModelEngine* self = CModel1ModelEngine::NewLC(
        aOForm, aOLift); 
	CleanupStack::Pop(self);
    return self;
    }

CModel1ModelEngine* CModel1ModelEngine::NewLC(
        ru.ifmo.lift.MainForm* aOForm,
        ru.ifmo.lift.Lift* aOLift)
    {
    CModel1ModelEngine* self = new (ELeave) CModel1ModelEngine;
    CleanupStack::PushL(self);
    self->ConstructL(
        aOForm, aOLift); 
    return self;
    }

void CModel1ModelEngine::ConstructL(
        ru.ifmo.lift.MainForm* aOForm,
        ru.ifmo.lift.Lift* aOLift)
	{
	iLiftAutomat = new (ELeave) TLiftAutomat(*this);

	iLiftAutomat->SetOForm(aOForm);
	iLiftAutomat->SetOLift(aOLift);
	}

CModel1ModelEngine::~CModel1ModelEngine()
	{
	if (iLiftAutomat)
		{
		delete iLiftAutomat;
		iLiftAutomat = NULL;
		}
	}

/*
 * Returns name of the given event
 */
const TDesC& CModel1ModelEngine::EventName(CModel1ModelEngine::EEvent anEvent) const
	{
	switch (anEvent)
	    {
	    case CLOSE_THE_DOORS:
			{
			_LIT(KEventName, "CloseTheDoors");
		    return KEventName;
			}
	    case EXIT:
			{
			_LIT(KEventName, "Exit");
		    return KEventName;
			}
	    case GO_DOWN:
			{
			_LIT(KEventName, "GoDown");
		    return KEventName;
			}
	    case GO_UP:
			{
			_LIT(KEventName, "GoUp");
		    return KEventName;
			}
	    case HAS_BEEN_REPAIRED:
			{
			_LIT(KEventName, "HasBeenRepaired");
		    return KEventName;
			}
	    case HAS_BROKEN:
			{
			_LIT(KEventName, "HasBroken");
		    return KEventName;
			}
	    case NEW_TASK_ADDED:
			{
			_LIT(KEventName, "NewTaskAdded");
		    return KEventName;
			}
	    case OPEN_THE_DOORS:
			{
			_LIT(KEventName, "OpenTheDoors");
		    return KEventName;
			}
	    case QUEUE_IS_EMPTY:
			{
			_LIT(KEventName, "QueueIsEmpty");
		    return KEventName;
			}

        default:
			{
			_LIT(KEventName, "*");
			return KEventName;
			}
		}
	}

void CModel1ModelEngine::HandleL(CModel1ModelEngine::EEvent aEvent)
	{
	iLiftAutomat->HandleL(aEvent, iContext);
	}
void CModel1BaseMachine::DoLogL(TDesC& message)
	{
	TBuf8<128> message8;
	message8.Copy(message);
	iModel.Log()->WriteL(message8);
	iModel.Log()->CommitL();
	}

void CModel1BaseMachine::LogBeginL(const TDesC& aStateName, CAutoAnswererModelEngine::EEvent aEvent)
	{
	_LIT(KFormat, "%S:[%S] on %S\n");
	TBuf<128> message;
	message.Format(KFormat, &MachineName(), &aStateName, &iModel.EventName(aEvent));
	DoLogL(message);
	}
	
void CModel1BaseMachine::LogTransiteL(const TDesC& aOldStateName, const TDesC& aNewStateName)
	{
	_LIT(KFormat, "  %S:[%S] => [%S]\n");
	TBuf<128> message;
	message.Format(KFormat, &MachineName(), &aOldStateName, &aNewStateName);
	DoLogL(message);
	}
	
void CModel1BaseMachine::LogEndL(const TDesC& aStateName, CAutoAnswererModelEngine::EEvent /*aEvent*/)
	{
	_LIT(KFormat, "%S:[%S]\n\n");
	TBuf<128> message;
	message.Format(KFormat, &MachineName(), &aStateName);
	DoLogL(message);
	}
	
void CModel1BaseMachine::LogActionBeginL(const TDesC& anIdentifier)
	{
	_LIT(KFormat, "  %S {\n");
	TBuf<128> message;
	message.Format(KFormat, &anIdentifier);
	DoLogL(message);
	}
	
void CModel1BaseMachine::LogActionEndL(const TDesC& anIdentifier)
	{
	_LIT(KFormat, "  %S }\n");
	TBuf<128> message;
	message.Format(KFormat, &anIdentifier);
	DoLogL(message);
	}
	
void CModel1BaseMachine::LogActionEndL(const TDesC& anIdentifier, TInt aValue)
	{
	_LIT(KFormat, "  %S = %d }\n");
	TBuf<128> message;
	message.Format(KFormat, &anIdentifier, aValue);
	DoLogL(message);
	}


///////////////////////////////////////////////////////////////////////////
// Automaton liftAutomat section
///////////////////////////////////////////////////////////////////////////

/*
 * Executes on enter actions of the given state of automaton liftAutomat
 */
void TLiftAutomat::EnterStateL(TLiftAutomat::EState aState, TStateMachineContext& aContext)
	{
	switch (aState)
	    {
	    case __1:
            iOLift->WaitOpenedL(aContext);
			break;
	    case __2:
            iOLift->WaitOpenedL(aContext);
			break;
	    case TOP:
			break;
	    case ___:
            iOForm->ShowBreakageMsgL(aContext);
			break;
	    case _:
            iOLift->GoUpL(aContext);
			break;
	    case _:
            iOLift->ChooseDirectionL(aContext);
			break;
	    case _:
            iOLift->GoDownL(aContext);
			break;
	    case FINAL_STATE:
			break;
	    case ___:
            iOForm->ShowBreakageMsgL(aContext);
			break;
		}
	}

/*
 * Checks whether given state of automaton liftAutomat is stable.
 */
TBool TLiftAutomat::IsStable(TLiftAutomat::EState aState) const
	{
	return 
        aState == TLiftAutomat::EState::__1 ||
        aState == TLiftAutomat::EState::__2 ||
        aState == TLiftAutomat::EState::___ ||
        aState == TLiftAutomat::EState::_ ||
        aState == TLiftAutomat::EState::_ ||
        aState == TLiftAutomat::EState::_ ||
        aState == TLiftAutomat::EState::FINAL_STATE ||
        aState == TLiftAutomat::EState::___ ||
        FALSE;
	}

/*
 * Returns superstate of the given state of automaton liftAutomat
 */
const TDesC& TLiftAutomat::StateName(TLiftAutomat::EState aState) const
	{
	switch (aState)
	    {
	    case __1:
			{
			_LIT(KStateName, "  1");
		    return KStateName;
			}
	    case __2:
			{
			_LIT(KStateName, "  2");
		    return KStateName;
			}
	    case TOP:
			{
			_LIT(KStateName, "Top");
		    return KStateName;
			}
	    case ___:
			{
			_LIT(KStateName, "   ");
		    return KStateName;
			}
	    case _:
			{
			_LIT(KStateName, " ");
		    return KStateName;
			}
	    case _:
			{
			_LIT(KStateName, " ");
		    return KStateName;
			}
	    case _:
			{
			_LIT(KStateName, " ");
		    return KStateName;
			}
	    case FINAL_STATE:
			{
			_LIT(KStateName, "FinalState");
		    return KStateName;
			}
	    case ___:
			{
			_LIT(KStateName, "   ");
		    return KStateName;
			}
        default:
			{
			_LIT(KStateName, "<<Unknown>>");
			return KStateName;
			}
		}
	}

/*
 * Returns name of the machine
 */
const TDesC& TLiftAutomat::MachineName() const
	{
	_LIT(KName, "liftAutomat");
    return KName;
	}

/*
 * Returns superstate of the given state of automaton liftAutomat
 */
TLiftAutomat::EState TLiftAutomat::GetSuperstate(TLiftAutomat::EState aState) const
	{
	switch (aState)
	    {
	    case __1:
		    return TOP;
	    case __2:
		    return TOP;
	    case ___:
		    return TOP;
	    case _:
		    return TOP;
	    case _:
		    return TOP;
	    case _:
		    return TOP;
	    case FINAL_STATE:
		    return TOP;
	    case ___:
		    return TOP;
        default:
			// For top and unexisting states
			return UNKNOWN_STATE;
		}
	}

/*
 * For stable state immediately returns itself. For unstable state transites
 * to corresponding stable invoking all actions on transitions.
 */
TLiftAutomat::EState TLiftAutomat::TransiteToStableL(TLiftAutomat::EState aState, TStateMachineContext& aContext)
    {	
	EState newState = aState;
	while (!IsStable(newState)) 
        {
		switch (newState)
		    {
            case TOP:				
                newState = _;
                LogTransiteL(StateName(INITIAL_STATE), StateName(newState));
                EnterStateL(newState, aContext);
			    break;
			default: ;// Impossible case
			}
        }
	return newState;
	}

/*
 * Selects transition and transites.
 */
TLiftAutomat::EState TLiftAutomat::TransiteOnEventL(CModel1ModelEngine::EEvent aEvent, TStateMachineContext& aContext)
	{
	TLiftAutomat::EState targetState = UNKNOWN_STATE;
	for (TLiftAutomat::EState sourceState = iState; targetState == UNKNOWN_STATE && sourceState != TOP; sourceState = GetSuperstate(sourceState))
		{
        switch (sourceState) 
    	    {
            /* State:   1 */
            case __1:
                switch (aEvent)
    			    {
					case CModel1ModelEngine::EEvent::CLOSE_THE_DOORS:
                        iOLift->CloseTheDoorsL(aContext);
                        targetState = _;
                        LogTransiteL(StateName(__1), StateName(targetState));
                        EnterStateL(targetState, aContext);
	                    break;
                    default: ;// Do nothing if no event was triggered
					}
			    break;
            /* State:   2 */
            case __2:
                switch (aEvent)
    			    {
					case CModel1ModelEngine::EEvent::CLOSE_THE_DOORS:
                        iOLift->CloseTheDoorsL(aContext);
                        targetState = _;
                        LogTransiteL(StateName(__2), StateName(targetState));
                        EnterStateL(targetState, aContext);
	                    break;
                    default: ;// Do nothing if no event was triggered
					}
			    break;
            /* State: Top */
            case TOP:
                switch (aEvent)
    			    {
                    default: ;// Do nothing if no event was triggered
					}
			    break;
            /* State:     */
            case ___:
                switch (aEvent)
    			    {
					case CModel1ModelEngine::EEvent::HAS_BEEN_REPAIRED:
                        targetState = _;
                        LogTransiteL(StateName(___), StateName(targetState));
                        EnterStateL(targetState, aContext);
	                    break;
                    default: ;// Do nothing if no event was triggered
					}
			    break;
            /* State:   */
            case _:
                switch (aEvent)
    			    {
					case CModel1ModelEngine::EEvent::HAS_BROKEN:
                        targetState = ___;
                        LogTransiteL(StateName(_), StateName(targetState));
                        EnterStateL(targetState, aContext);
	                    break;
					case CModel1ModelEngine::EEvent::OPEN_THE_DOORS:
                        iOForm->UpdateButtonsL(aContext);
                        iOLift->OpenTheDoorsL(aContext);
                        targetState = __1;
                        LogTransiteL(StateName(_), StateName(targetState));
                        EnterStateL(targetState, aContext);
	                    break;
					case CModel1ModelEngine::EEvent::QUEUE_IS_EMPTY:
                        iOLift->ChangeDirectionL(aContext);
                        targetState = _;
                        LogTransiteL(StateName(_), StateName(targetState));
                        EnterStateL(targetState, aContext);
	                    break;
                    default: ;// Do nothing if no event was triggered
					}
			    break;
            /* State:   */
            case _:
                switch (aEvent)
    			    {
					case CModel1ModelEngine::EEvent::EXIT:
                        iOForm->CloseFormL(aContext);
                        targetState = FINAL_STATE;
                        LogTransiteL(StateName(_), StateName(targetState));
                        EnterStateL(targetState, aContext);
	                    break;
					case CModel1ModelEngine::EEvent::GO_DOWN:
                        targetState = _;
                        LogTransiteL(StateName(_), StateName(targetState));
                        EnterStateL(targetState, aContext);
	                    break;
					case CModel1ModelEngine::EEvent::GO_UP:
                        targetState = _;
                        LogTransiteL(StateName(_), StateName(targetState));
                        EnterStateL(targetState, aContext);
	                    break;
					case CModel1ModelEngine::EEvent::NEW_TASK_ADDED:
                        targetState = _;
                        LogTransiteL(StateName(_), StateName(targetState));
                        EnterStateL(targetState, aContext);
	                    break;
                    default: ;// Do nothing if no event was triggered
					}
			    break;
            /* State:   */
            case _:
                switch (aEvent)
    			    {
					case CModel1ModelEngine::EEvent::HAS_BROKEN:
                        targetState = ___;
                        LogTransiteL(StateName(_), StateName(targetState));
                        EnterStateL(targetState, aContext);
	                    break;
					case CModel1ModelEngine::EEvent::OPEN_THE_DOORS:
                        iOForm->UpdateButtonsL(aContext);
                        iOLift->OpenTheDoorsL(aContext);
                        targetState = __2;
                        LogTransiteL(StateName(_), StateName(targetState));
                        EnterStateL(targetState, aContext);
	                    break;
					case CModel1ModelEngine::EEvent::QUEUE_IS_EMPTY:
                        iOLift->ChangeDirectionL(aContext);
                        targetState = _;
                        LogTransiteL(StateName(_), StateName(targetState));
                        EnterStateL(targetState, aContext);
	                    break;
                    default: ;// Do nothing if no event was triggered
					}
			    break;
            /* State: FinalState */
            case FINAL_STATE:
                switch (aEvent)
    			    {
                    default: ;// Do nothing if no event was triggered
					}
			    break;
            /* State:     */
            case ___:
                switch (aEvent)
    			    {
					case CModel1ModelEngine::EEvent::HAS_BEEN_REPAIRED:
                        targetState = _;
                        LogTransiteL(StateName(___), StateName(targetState));
                        EnterStateL(targetState, aContext);
	                    break;
                    default: ;// Do nothing if no event was triggered
					}
			    break;
			}
		}
		
	// Look for default transition
	for (TLiftAutomat::EState sourceState = iState; targetState == UNKNOWN_STATE && sourceState != TOP; sourceState = GetSuperstate(sourceState))
		{
        switch (sourceState) 
    	    {
            /* State:   1 */
            case __1:
			    break;
            /* State:   2 */
            case __2:
			    break;
            /* State: Top */
            case TOP:
			    break;
            /* State:     */
            case ___:
			    break;
            /* State:   */
            case _:
			    break;
            /* State:   */
            case _:
			    break;
            /* State:   */
            case _:
			    break;
            /* State: FinalState */
            case FINAL_STATE:
			    break;
            /* State:     */
            case ___:
			    break;
			}
		}
	
	// If no transition was found stay in current state
	return targetState != UNKNOWN_STATE ? targetState : iState;
	}

void TLiftAutomat::InvokeSubmachinesL(CModel1ModelEngine::EEvent aEvent, TStateMachineContext& aContext)
	{
	for (EState curState = iState; curState != TOP; curState = GetSuperstate(curState))
		{
        switch (curState)
    	    {
            /* State:   1 */
            case __1:
			    break;
            /* State:   2 */
            case __2:
			    break;
            /* State: Top */
            case TOP:
			    break;
            /* State:     */
            case ___:
			    break;
            /* State:   */
            case _:
			    break;
            /* State:   */
            case _:
			    break;
            /* State:   */
            case _:
			    break;
            /* State: FinalState */
            case FINAL_STATE:
			    break;
            /* State:     */
            case ___:
			    break;
			}
		}
	}

void TLiftAutomat::HandleL(CModel1ModelEngine::EEvent aEvent, TStateMachineContext& aContext)
	{
	// Init state machine liftAutomat if it is in its top state
	if (iState == EState::TOP) 
		{
		iState = TransiteToStableL(EState::TOP, aContext);
		}
	
	LogBeginL(StateName(iState), aEvent);
	EState newState = TransiteOnEventL(aEvent, aContext);
	iState = TransiteToStableL(newState, aContext);
	InvokeSubmachinesL(aEvent, aContext);
	LogEndL(StateName(iState), aEvent);
	}

